/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/

/*
 *@Note
   ȡַָֽڡ֡
*/

#include "debug.h"

u32 flashbuf[10]={0};


//ȡַָһֽ(8λ)
uint8_t FLASH_ReadByte(uint32_t address)
{
   return *(__IO uint8_t*)address;
}

//ȡַָİ(16λ)
uint16_t FLASH_ReadHalfWord(uint32_t address)
{
   return *(__IO uint16_t*)address;
}

//ȡַָ(32λ)
uint32_t FLASH_ReadWord(uint32_t address)
{
   return *(__IO uint32_t*)address;
}

//ַָʼȡ(32λ)
void FLASH_ReadWordAdd(uint32_t address, u32 *buff, uint16_t length)
{
    uint16_t i;

    for(i=0;i<length;i++)
    {
        buff[i] = *(__IO uint32_t*)address;;//ַָһֵ
        address += 4;
    }
}


/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
    u16 i;
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);

	FLASH_ReadWordAdd(0x08000080,flashbuf,10);

	printf("u8:%02x\r\n",FLASH_ReadByte(0x08000080));
	printf("u16:%04x\r\n",FLASH_ReadHalfWord(0x08000080));
	printf("u32:%08x\r\n",FLASH_ReadWord(0x08000080));

    for(i=0;i<10;i++)
    {
        printf("u32:%08x\r\n",flashbuf[i]);
    }

	while(1)
	{

	}
}

